import { writable } from 'svelte/store';

import { getTracks } from '$lib/track'

function createTracksStore() {
  const { subscribe, set, update } = writable({list: null});

  return {
    subscribe,

    set: (v) => {
      update((m) => Object.assign(m, v));
    },

    refresh: async () => {
      const list = await getTracks();
      update((m) => Object.assign(m, {list}));
      return list;
    },

    update: (res_tracks, cb=null) => {
      if (res_tracks.status === 200) {
        res_tracks.json().then((list) => {
          update((m) => (Object.assign(m, {list})));

          if (cb) {
            cb(list);
          }
        });
      }
    },
  };

}

export const tracks = createTracksStore();
